// EssKaliStd.cpp : Defines the entry point for the application.

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <fstream.h>

void initSynth();
void exitSynth();
extern int (_stdcall *MessageKali)(unsigned char* texte);
extern int (_stdcall *QueryIndexKali)();
extern void (_stdcall* SetDiagLangueKali)(short diagLangue);
extern void (_stdcall* SetSortieSonMultiKali)(short nK, bool sortieSon);
extern void (_stdcall* SetSortieWaveMultiKali)(short nK, bool sortieWave);
extern void (_stdcall* SetNomFichierWaveMultiKali)(short nK, char *nomFichierWave);

int main(int argc, char** argv) {

	if (argc!=4) {	//pas d'arguments (ou un nombre non prvu)
		//1er exemple : sortie son. Kali prononce un message, sortie sur la carte son
		initSynth();	//charge la dll et prpare les pointeurs sur les fonctions de Kali
		while (QueryIndexKali()>0)	 //attend le chargement de Kali (-> "Kali prt")
			Sleep(0);
		SetDiagLangueKali(1);	//Active le diagnostique automatique de langue (ou pas...)
		SetSortieSonMultiKali(0, true);	//sortie son
		SetSortieWaveMultiKali(0, false);	//pas sortie wave
		MessageKali((unsigned char*)"Ceci est le message que je prononce.");
	} else {
		//2e exemple : sortie wave. Kali est utilis avec 3 arguments : le texte  lire, l'endroit o il copie le wave rsultant, les rglages  prendre en compte.
		//Exemple rudimentaire : il faudrait tester la prsence des rpertoires et fichiers utiliss
		ifstream src(argv[3],ios::binary);	  //ce fichier doit tre identique  un KaliWin.ini valide
		ofstream dst("C:\\ini\\Kali\\KaliWin.ini",ios::binary);
		dst<<src.rdbuf();	//copie le ini fourni dans C:\ini\Kali\KaliWin.ini
		src.close();
		dst.close();
		initSynth();	//charge la dll et prpare les pointeurs sur les fonctions de Kali (aprs copie de KaliWin.ini pour prendre en compte les rglages)
		SetSortieSonMultiKali(0, false);	//pas sortie son
		SetSortieWaveMultiKali(0, true);	//sortie wave
		SetNomFichierWaveMultiKali(0, (char*)argv[2]);	//chemin et nom du fichier wave
		//Envoi du message
		MessageKali((unsigned char*)argv[1]);
	}

	//Attend que Kali ait termin
	while(QueryIndexKali()>0)
		Sleep(0);
	//Dcharge Kali (obligatoire avant de quitter une application parlante)
	exitSynth();
	return(0);
}
