#include <windows.h>
#include "essaiKaliStd.h"

HINSTANCE DLL;

void initSynth() {
	DLL = LoadLibrary("kali.dll");
//	DLL = LoadLibrary("kali_.dll");
//	DLL = LoadLibrary("C:\\Michel\\Kali\\src\\x64\\Debug\\Kali_.dll");
//	DLL = LoadLibrary("C:\\Michel\\Kali\\src\\Debug\\Kali_.dll");
	//Fonctions de contrle de Kali
#ifdef _WIN64
	MessageKali = (int (_stdcall*)(unsigned char* texte)) GetProcAddress(DLL,"MessageKaliStd");
	DWORD err = GetLastError();
	QueryIndexKali = (int (_stdcall*)(void)) GetProcAddress(DLL,"QueryIndexKaliStd");
	GetPosLecKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetPosLecKaliStd");
	StopKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"StopKaliStd");
	//Fonctions de paramtrage de kali
	SetDiagLangueKali = (void (_stdcall*)(short diagLangue)) GetProcAddress(DLL,"SetDiagLangueKaliStd");
	GetDiagLangueKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetDiagLangueKaliStd");
	SetLangueKali = (void (_stdcall*)(char nLangue)) GetProcAddress(DLL,"SetLangueKaliStd");
	GetLangueKali = (char (_stdcall*)(void)) GetProcAddress(DLL,"GetLangueKaliStd");
	GetNbLanguesKali = (char (_stdcall*)(void)) GetProcAddress(DLL,"GetNbLanguesKaliStd");
	GetNomLangueKali = (char* (_stdcall*)(char nLangue, char* nomLangue)) GetProcAddress(DLL,"GetNomLangueKaliStd");
	GetNLangueVoixKali = (char (_stdcall*)(char nVoix)) GetProcAddress(DLL,"GetNLangueVoixKaliStd");
	SetVoixKali = (void (_stdcall*)(char nVoix)) GetProcAddress(DLL,"SetVoixKaliStd");
	GetVoixKali = (char (_stdcall*)(void)) GetProcAddress(DLL,"GetVoixKaliStd");
	GetNbVoixKali = (char (_stdcall*)(void)) GetProcAddress(DLL,"GetNbVoixKaliStd");
	SetVolumeKali = (void (_stdcall*)(short volume)) GetProcAddress(DLL,"SetVolumeKaliStd");
	GetVolumeKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetVolumeKaliStd");
	SetDebitKali = (void (_stdcall*)(short debit)) GetProcAddress(DLL,"SetDebitKaliStd");
	GetDebitKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetDebitKaliStd");
	SetHauteurKali = (void (_stdcall*)(short hauteur)) GetProcAddress(DLL,"SetHauteurKaliStd");
	GetHauteurKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetHauteurKaliStd");
	SetModeLectureKali = (void (_stdcall*)(short modeLecture)) GetProcAddress(DLL,"SetModeLectureKaliStd");
	GetModeLectureKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetModeLectureKaliStd");
	SetComptaKali = (void (_stdcall*)(short compta)) GetProcAddress(DLL,"SetComptaKaliStd");
	GetComptaKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetComptaKaliStd");
	SetEpelleKali = (void (_stdcall*)(short epelle)) GetProcAddress(DLL,"SetEpelleKaliStd");
	GetEpelleKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetEpelleKaliStd");
	SetArticuleKali = (void (_stdcall*)(short epelle)) GetProcAddress(DLL,"SetArticuleKaliStd");
	GetArticuleKali = (short (_stdcall*) (void)) GetProcAddress(DLL,"GetArticuleKaliStd");
	SetSyntaxeKali = (void (_stdcall*)(short syntaxe)) GetProcAddress(DLL,"SetSyntaxeKaliStd");
	GetSyntaxeKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetSyntaxeKaliStd");
	SetProsodieKali = (void (_stdcall*)(short prosodie)) GetProcAddress(DLL,"SetProsodieKaliStd");
	GetProsodieKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetProsodieKaliStd");
	SetCoefPauseKali = (void (_stdcall*)(short coefPause)) GetProcAddress(DLL,"SetCoefPauseKaliStd");
	GetCoefPauseKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetCoefPauseKaliStd");
	SetProsoNatKali = (void (_stdcall*)(short coefProsoNat)) GetProcAddress(DLL,"SetProsoNatKaliStd");
	GetProsoNatKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"GetProsoNatKaliStd");
	SauveInitKali = (void (_stdcall*)(void)) GetProcAddress(DLL,"SauveInitKaliStd");
	ExitKali = (void (_stdcall*)(void)) GetProcAddress(DLL,"ExitKaliStd");
	SetSortieSonMultiKali = (void (_stdcall*)(short, bool)) GetProcAddress(DLL,"SetSortieSonMultiKaliStd");
	SetSortieWaveMultiKali = (void (_stdcall*)(short, bool) GetProcAddress(DLL,"SetSortieWaveMultiKaliStd");
	SetNomFichierWaveMultiKali = (void (_stdcall*)(short, char*) GetProcAddress(DLL,"SetNomFichierWaveMultiKaliStd");
#else
	MessageKali = (int (_stdcall*)(unsigned char* texte)) GetProcAddress(DLL,"_MessageKaliStd@4");
	DWORD err = GetLastError();
	QueryIndexKali = (int (_stdcall*)(void)) GetProcAddress(DLL,"_QueryIndexKaliStd@0");
	GetPosLecKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetPosLecKaliStd@0");
	StopKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_StopKaliStd@0");
	//Fonctions de paramtrage de kali
	SetDiagLangueKali = (void (_stdcall*)(short diagLangue)) GetProcAddress(DLL,"_SetDiagLangueKaliStd@4");
	GetDiagLangueKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetDiagLangueKaliStd@0");
	SetLangueKali = (void (_stdcall*)(char nLangue)) GetProcAddress(DLL,"_SetLangueKaliStd@4");
	GetLangueKali = (char (_stdcall*)(void)) GetProcAddress(DLL,"_GetLangueKaliStd@0");
	GetNbLanguesKali = (char (_stdcall*)(void)) GetProcAddress(DLL,"_GetNbLanguesKaliStd@0");
	GetNomLangueKali = (char* (_stdcall*)(char nLangue, char* nomLangue)) GetProcAddress(DLL,"_GetNomLangueKaliStd@8");
	GetNLangueVoixKali = (char (_stdcall*)(char nVoix)) GetProcAddress(DLL,"_GetNLangueVoixKaliStd@4");
	SetVoixKali = (void (_stdcall*)(char nVoix)) GetProcAddress(DLL,"_SetVoixKaliStd@4");
	GetVoixKali = (char (_stdcall*)(void)) GetProcAddress(DLL,"_GetVoixKaliStd@0");
	GetNbVoixKali = (char (_stdcall*)(void)) GetProcAddress(DLL,"_GetNbVoixKaliStd@0");
	SetVolumeKali = (void (_stdcall*)(short volume)) GetProcAddress(DLL,"_SetVolumeKaliStd@4");
	GetVolumeKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetVolumeKaliStd@0");
	SetDebitKali = (void (_stdcall*)(short debit)) GetProcAddress(DLL,"_SetDebitKaliStd@4");
	GetDebitKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetDebitKaliStd@0");
	SetHauteurKali = (void (_stdcall*)(short hauteur)) GetProcAddress(DLL,"_SetHauteurKaliStd@4");
	GetHauteurKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetHauteurKaliStd@0");
	SetModeLectureKali = (void (_stdcall*)(short modeLecture)) GetProcAddress(DLL,"_SetModeLectureKaliStd@4");
	GetModeLectureKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetModeLectureKaliStd@0");
	SetComptaKali = (void (_stdcall*)(short compta)) GetProcAddress(DLL,"_SetComptaKaliStd@4");
	GetComptaKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetComptaKaliStd@0");
	SetEpelleKali = (void (_stdcall*)(short epelle)) GetProcAddress(DLL,"_SetEpelleKaliStd@4");
	GetEpelleKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetEpelleKaliStd@0");
	SetArticuleKali = (void (_stdcall*)(short epelle)) GetProcAddress(DLL,"_SetArticuleKaliStd@4");
	GetArticuleKali = (short (_stdcall*) (void)) GetProcAddress(DLL,"_GetArticuleKaliStd@0");
	SetSyntaxeKali = (void (_stdcall*)(short syntaxe)) GetProcAddress(DLL,"_SetSyntaxeKaliStd@4");
	GetSyntaxeKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetSyntaxeKaliStd@0");
	SetProsodieKali = (void (_stdcall*)(short prosodie)) GetProcAddress(DLL,"_SetProsodieKaliStd@4");
	GetProsodieKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetProsodieKaliStd@0");
	SetCoefPauseKali = (void (_stdcall*)(short coefPause)) GetProcAddress(DLL,"_SetCoefPauseKaliStd@4");
	GetCoefPauseKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetCoefPauseKaliStd@0");
	SetProsoNatKali = (void (_stdcall*)(short coefProsoNat)) GetProcAddress(DLL,"_SetProsoNatKaliStd@4");
	GetProsoNatKali = (short (_stdcall*)(void)) GetProcAddress(DLL,"_GetProsoNatKaliStd@0");
	SauveInitKali = (void (_stdcall*)(void)) GetProcAddress(DLL,"_SauveInitKaliStd@0");
	ExitKali = (void (_stdcall*)(void)) GetProcAddress(DLL,"_ExitKaliStd@0");
	SetSortieSonMultiKali = (void (_stdcall*)(short, bool)) GetProcAddress(DLL,"_SetSortieSonMultiKaliStd@8");
	SetSortieWaveMultiKali = (void (_stdcall*)(short, bool)) GetProcAddress(DLL,"_SetSortieWaveMultiKaliStd@8");
	SetNomFichierWaveMultiKali = (void (_stdcall*)(short, char*)) GetProcAddress(DLL,"_SetNomFichierWaveMultiKaliStd@8");
#endif
}

void exitSynth() {
	ExitKali();	//stoppe Kali
	FreeLibrary(DLL);	//dcharge la DLL Kali
}