VERSION 5.00
Begin VB.Form MonApp 
   Caption         =   "MonAppKali"
   ClientHeight    =   4065
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6105
   LinkTopic       =   "MonAppKali"
   ScaleHeight     =   4065
   ScaleWidth      =   6105
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Stop 
      Caption         =   "&Stop"
      Height          =   615
      Left            =   2760
      TabIndex        =   4
      Top             =   3360
      Width           =   1335
   End
   Begin VB.Timer Timer1 
      Interval        =   50
      Left            =   0
      Top             =   3360
   End
   Begin VB.TextBox texIndex 
      Height          =   285
      Left            =   4920
      TabIndex        =   2
      Top             =   3600
      Width           =   495
   End
   Begin VB.CommandButton Parler 
      Caption         =   "&Parler"
      Height          =   615
      Left            =   600
      TabIndex        =   1
      Top             =   3360
      Width           =   1815
   End
   Begin VB.TextBox texte 
      Height          =   3015
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   5775
   End
   Begin VB.Label Label1 
      Caption         =   "index"
      Height          =   255
      Left            =   4440
      TabIndex        =   3
      Top             =   3600
      Width           =   375
   End
End
Attribute VB_Name = "MonApp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Bote de dialogue permettant d'envoyer un texte  Kali et de suivre la lecture
'_______________________________________________________________


Option Explicit

Const NB_MOTS_MAX = 1000
'Globales
Dim texteKali As String 'texte avec index,  envoyer  Kali
Dim lgTexte As Integer
Dim nbMots As Integer
Dim iMot As Integer  'rang du mot en lecture
Dim indexLecPrc As Integer
Dim tPosLec(1 To NB_MOTS_MAX) As Integer    'tableau des positions des mots
Dim tLongMot(1 To NB_MOTS_MAX) As Integer   'tableau des longueurs de mots
Dim marqMot As Boolean  'vrai si mot

Private Sub Stop_Click()
    StopKali
    texte.SetFocus  'remet le focus sur le texte pour pouvoir le modifier
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'SauveInitKali 'sauvegarde les paramtres actuels de Kali (facultatif)
    ExitKali    'obligatoire avant de quitter une application utilisant Kali
End Sub

'Envoie le message tap aprs quelques rglages
Private Sub Parler_Click()
 
    SetLangueKali 1   'franais
    SetVoixKali 3   'voix Guillemette
    SetVolumeKali 10
    SetDebitKali 5
    SetHauteurKali 6
    SetModeLectureKali 0
    SetComptaKali 1
    SetEpelleKali 0
    SetSyntaxeKali 1
    SetProsodieKali 8
    SetCoefPauseKali 4
    SetLocalisationKali 50
    
    AjouteIndexEtReprage
    MessageKali texteKali  'envoie le message avec index
    texte.SetFocus  'remet le focus sur le texte pour pouvoir le modifier
End Sub

Public Sub AjouteIndexEtReprage()
    Dim carSep, lettres As String
    Dim iCar As Integer
    Dim car As String
    Dim CAR_SEP As String
    Dim LETTRE As String
    
    CAR_SEP = Chr(10) & Chr(13) & Chr(9) & ". " & "!:;,?)({[]}\"        'caractres sparateurs
    LETTRE = "-'abcdefghijklmnopqrstuvwxyz1234567890"       'lettres valides
    lgTexte = Len(texte.Text)
    marqMot = False 'avant le 1er mot  reprer
    nbMots = 0
    texteKali = ""
    For iCar = 1 To lgTexte
        car = Mid(LCase(texte.Text), iCar, 1)
        If Not marqMot And InStr(1, LETTRE, car) > 0 Then '1re lettre d'un mot
            texteKali = texteKali & ""  'pose d'un index devant le mot
            nbMots = nbMots + 1
            tPosLec(nbMots) = iCar  'repre le dbut du mot
            marqMot = True
        ElseIf marqMot And InStr(CAR_SEP, car) > 0 Then  '1er caractre derrre un mot
            texteKali = texteKali & ""  'pose d'un index derrire le mot
            tLongMot(nbMots) = iCar - tPosLec(nbMots)   'note la longueur du mot
            marqMot = False
        End If
        texteKali = texteKali & car
    Next
    If marqMot Then   'cas o le texte finit par une lettre
        texteKali = texteKali & "" 'index derrire le dernier mot
        tLongMot(nbMots) = iCar - tPosLec(nbMots)   'note la longueur du mot
    End If
    iMot = 1 'pour commencer le reprage de lecture
    indexLecPrc = nbMots * 2   'nb d'index poss
    marqMot = False 'avant le 1er mot  lire
    texIndex.Text = Str(indexLecPrc)
End Sub

'Mise  jour permanente de l'index
Private Sub Timer1_Timer()
    Dim indexReste As Integer

    indexReste = QueryIndexKali
    If nbMots = 0 Then Exit Sub
    If indexReste < indexLecPrc Then
        texIndex.Text = Str(indexReste) 'affiche l'index seulement s'il change
        indexLecPrc = indexLecPrc - 1 'pour avancer d'un index  la fois (sinon on risque de sauter les mots courts)
        If Not marqMot Then
            texte.SelStart = tPosLec(iMot) - 1
            texte.SelLength = tLongMot(iMot)
            marqMot = True
        ElseIf marqMot Then
            texte.SelStart = tPosLec(iMot) + tLongMot(iMot) - 1
            If iMot < nbMots Then
'                texte.SelLength = tPosLec(iMot + 1) - tPosLec(iMot) - tLongMot(iMot)
                iMot = iMot + 1
            Else
                texte.SelLength = lgTexte + 1 - tPosLec(iMot) - tLongMot(iMot)
            End If
            marqMot = False
        End If
        If indexReste = 0 Then texte.SelStart = lgTexte
    End If
End Sub
